﻿/*Copyright 2025 Wojciech Christopher Peter Fiałkiewicz

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ListPrimeNumbers
{
    internal class Program
    {
        public static bool IsPrimeNumber(ulong nr)
        {
            ulong half = nr / 2;

            if (nr == 0 || nr == 1)
            {
                return false;
            }
            for (ulong i = 2; i <= half; i++)
            {
                if (nr % i == 0)
                {
                    return false;
                }
            }
            return true;
        }

        public static bool IsPrimeNumberFaster(ulong nr)
        {
            ulong max = nr / 2;

            if (nr == 0 || nr == 1)
            {
                return false;
            }
            for (ulong i = 2; i <= max; i++)
            {
                if (IsPrimeNumber(i))
                {
                    max = nr / i;
                }
                if (nr % i == 0)
                {
                    return false;
                }
            }
            return true;
        }

        public static bool IsPrimeNumberEvenFaster(ulong nr)
        {
            ulong max = nr / 2;
            ulong j = 1;
            bool can_not_be = false;

            if (nr == 0 || nr == 1)
            {
                return false;
            }
            for (ulong i = 2; i <= max; i++)
            {
                if (nr >= 10000000000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0 || j % 17 != 0 || j % 19 != 0 || j % 23 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 1000000000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0 || j % 17 != 0 || j % 19 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 100000000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0 || j % 17 != 0 || j % 19 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 10000000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0 || j % 17 != 0 || j % 19 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 1000000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0 || j % 17 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 100000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0 || j % 17 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 10000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0 || j % 17 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 1000000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 100000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 10000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0 || j % 13 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 1000000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 100000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0 || j % 11 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 10000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 1000000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 100000 && (j % 2 != 0 || j % 3 != 0 || j % 5 != 0 || j % 7 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 10000 && (j % 2 != 0 || j % 3 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 1000 && (j % 2 != 0 || j % 3 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 100 && (j % 2 != 0))
                {
                    can_not_be = true;
                }
                else if (nr >= 10 && (j % 2 != 0))
                {
                    can_not_be = true;
                }
                else
                {
                    can_not_be = false;
                }
                if (!can_not_be && IsPrimeNumberFaster(i))
                {
                    max = nr / i;
                    j = 0;
                }
                j++;
                if (nr % i == 0)
                {
                    return false;
                }
            }
            return true;
        }

        static void CheckIfPrime(object ob)
        {
            ConcurrentDictionary<ulong, bool> bag = (ConcurrentDictionary<ulong, bool>)(ob);
            ulong start = 0;

            foreach(ulong key in bag.Keys)
            {
                if(start < key)
                {
                    start = key;
                }
            }

            bag[start] = IsPrimeNumberEvenFaster(start);
        }

        static int CountFoundPrimes(ConcurrentDictionary<ulong, bool> bag)
        {
            int count = 0;
            
            foreach(ulong key in bag.Keys)
            {
                if (bag[key])
                {
                    count++;
                }
            }

            return count;
        }

        static int CountCompletedTasks(List<Task> tasks)
        {
            int count = 0;

            foreach(Task t in tasks)
            {
                if(t.IsCompleted)
                {
                    count++;
                }
            }

            return count;
        }

        static List<ulong> ListPrimeNumbers(ulong start, int amount)
        {
            ConcurrentDictionary<ulong, bool> bag = new ConcurrentDictionary<ulong, bool>();
            List<Task> tasks = new List<Task>();
                      
            while (CountFoundPrimes(bag) < amount)
            {
                if (tasks.Count - CountCompletedTasks(tasks) < amount - CountFoundPrimes(bag))
                {
                    Action<object> action = new Action<object>(CheckIfPrime);
                    Task task = new Task(action, bag);

                    bag[start] = false;
                    tasks.Add(task);
                    task.Start();
                    start++;
                }
            }

            List<ulong> list = new List<ulong>();

            foreach(ulong key in bag.Keys)
            {
                if (bag[key])
                {
                    list.Add(key);
                }
            }

            list.Sort();
            return list;
        }

        static void Main(string[] args)
        {
            if(args.Count() != 2)
            {
                Console.WriteLine("ListPrimeNumbers.exe [number] [amount]");
                return;
            }

            ulong start = ulong.Parse(args[0]);
            int amount = int.Parse(args[1]);
            List<ulong> primes;
            DateTime beg = DateTime.Now;
            DateTime end;
            TimeSpan span;

            primes = ListPrimeNumbers(start, amount);
            end = DateTime.Now;
            span = end - beg;
            
            foreach(ulong prime in primes)
            {
                Console.WriteLine(prime);
            }

            Console.WriteLine(string.Format("Calculated in {0} Minutes, {1} Seconds, {2} Milliseconds.", span.Minutes, span.Seconds, span.Milliseconds));
        }
    }
}
